summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
authorBen Hutchings <ben.hutchings@codethink.co.uk>2020-09-16 21:43:34 +0100
committerBen Hutchings <ben.hutchings@codethink.co.uk>2020-09-17 02:50:36 +0100
commit4c7424821d8eb9d97a147e650e588aafbded753c (patch)
treedb61ea488d435833f101eec46ea9b62ede7d1504 /tests
parent2468e2b22c400343d665bba3ea8554fef024affc (diff)
downloadlorry-4c7424821d8eb9d97a147e650e588aafbded753c.tar.gz
tests: Add test of incremental cvs lorrying
This currently fails because git cvsimport doesn't really work with bare repositories.
Diffstat (limited to 'tests')
-rwxr-xr-xtests/cvs-incremental.script77
-rwxr-xr-xtests/cvs-incremental.setup65
-rw-r--r--tests/cvs-incremental.stdout53
3 files changed, 195 insertions, 0 deletions
diff --git a/tests/cvs-incremental.script b/tests/cvs-incremental.script
new file mode 100755
index 0000000..0a487a0
--- /dev/null
+++ b/tests/cvs-incremental.script
@@ -0,0 +1,77 @@
+#!/bin/sh
+#
+# Tests converting a simple CVS repository to git.
+#
+# Copyright (C) 2012, 2020 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+
+set -e
+
+logfile="$DATADIR/cvs-test-repo.log"
+workdir="$DATADIR/work-dir"
+workingcopy="$DATADIR/cvs-test-checkout"
+
+repo="$DATADIR/cvs-test-repo"
+export CVSROOT="$repo"
+
+normalize() {
+ sed -r -e '/hooks\/.*\.sample/d' \
+ -e "s/pack-[0-9a-z]+\.(idx|pack)$/pack-file/" \
+ -e "/\/objects\/info\/commit-graph$/d" \
+ -e "/\/objects\/pack\/pack-[0-9a-z]+\.bitmap$/d" \
+ -e "/\/\.cvsps\//d" \
+ -e "s|$DATADIR|DATADIR|g" "$@"
+}
+
+# CVS wants $USER, $LOGNAME, and $LOGNAME set to a real username.
+export USER=root
+export LOGNAME=$USER
+export USERNAME=$USER
+
+"${SRCDIR}/test-lorry" --pull-only --log="$logfile" --working-area="$workdir" \
+ "$DATADIR/cvs-test-repo.lorry" > /dev/null
+
+(
+ cd "$workingcopy/CVSROOT"
+
+ # ensure that this commit has a later timestamp than the last one
+ sleep 1
+
+ # append to the test file
+ echo "second line" >> test.txt
+
+ # make a commit
+ cvs -Q commit -m "second commit"
+)
+
+"${SRCDIR}/test-lorry" --pull-only --log="$logfile" --working-area="$workdir" \
+ "$DATADIR/cvs-test-repo.lorry" > /dev/null
+
+# verify that the git repository was created successfully
+(
+ cd "$workdir/cvs-test-repo/git-b/"
+
+ echo "branches:"
+ git show-ref | cut -d' ' -f2 | LC_ALL=C sort
+
+ echo "test file:"
+ git cat-file blob master:test.txt
+
+ echo "commit messages:"
+ git log --pretty='%s' master
+)
+
+find "$workdir/cvs-test-repo" | LC_ALL=C sort | normalize
diff --git a/tests/cvs-incremental.setup b/tests/cvs-incremental.setup
new file mode 100755
index 0000000..fee3eac
--- /dev/null
+++ b/tests/cvs-incremental.setup
@@ -0,0 +1,65 @@
+#!/bin/sh
+#
+# Creates a CVS repository with a single file and a single commit.
+#
+# Copyright (C) 2012, 2020 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+
+set -e
+
+# CVS wants $USER, $LOGNAME, and $LOGNAME set to a real username.
+export USER=root
+export LOGNAME=$USER
+export USERNAME=$USER
+
+# create the repository
+repo="$DATADIR/cvs-test-repo"
+export CVSROOT="$repo"
+export CVS_RSH=
+cvs init
+
+# create a local working copy
+workingcopy="$DATADIR/cvs-test-checkout"
+mkdir "$workingcopy"
+cd "$workingcopy"
+cvs checkout CVSROOT
+cd "$workingcopy/CVSROOT"
+
+# ensure that our commit has a later timestamp than cvs init's
+# "initial checkin"
+sleep 1
+
+# add the test file
+echo "first line" > test.txt
+cvs -Q add test.txt
+
+# make a commit
+cvs -Q commit -m "first commit"
+
+# create the .lorry file for the repository
+cat <<EOF > $DATADIR/cvs-test-repo.lorry
+{
+ "cvs-test-repo": {
+ "type": "cvs",
+ "url": "$repo",
+ "module": "CVSROOT"
+ }
+}
+EOF
+
+
+# create the working directory
+test -d "$DATADIR/work-dir" || mkdir "$DATADIR/work-dir"
diff --git a/tests/cvs-incremental.stdout b/tests/cvs-incremental.stdout
new file mode 100644
index 0000000..122d75c
--- /dev/null
+++ b/tests/cvs-incremental.stdout
@@ -0,0 +1,53 @@
+branches:
+refs/heads/master
+refs/heads/origin
+test file:
+first line
+second line
+commit messages:
+second commit
+first commit
+initial checkin
+DATADIR/work-dir/cvs-test-repo
+DATADIR/work-dir/cvs-test-repo/git-a
+DATADIR/work-dir/cvs-test-repo/git-a/.cvsps
+DATADIR/work-dir/cvs-test-repo/git-a/HEAD
+DATADIR/work-dir/cvs-test-repo/git-a/branches
+DATADIR/work-dir/cvs-test-repo/git-a/config
+DATADIR/work-dir/cvs-test-repo/git-a/description
+DATADIR/work-dir/cvs-test-repo/git-a/hooks
+DATADIR/work-dir/cvs-test-repo/git-a/info
+DATADIR/work-dir/cvs-test-repo/git-a/info/exclude
+DATADIR/work-dir/cvs-test-repo/git-a/info/refs
+DATADIR/work-dir/cvs-test-repo/git-a/lorry-update-count
+DATADIR/work-dir/cvs-test-repo/git-a/objects
+DATADIR/work-dir/cvs-test-repo/git-a/objects/info
+DATADIR/work-dir/cvs-test-repo/git-a/objects/info/packs
+DATADIR/work-dir/cvs-test-repo/git-a/objects/pack
+DATADIR/work-dir/cvs-test-repo/git-a/objects/pack/pack-file
+DATADIR/work-dir/cvs-test-repo/git-a/objects/pack/pack-file
+DATADIR/work-dir/cvs-test-repo/git-a/packed-refs
+DATADIR/work-dir/cvs-test-repo/git-a/refs
+DATADIR/work-dir/cvs-test-repo/git-a/refs/heads
+DATADIR/work-dir/cvs-test-repo/git-a/refs/tags
+DATADIR/work-dir/cvs-test-repo/git-b
+DATADIR/work-dir/cvs-test-repo/git-b/.cvsps
+DATADIR/work-dir/cvs-test-repo/git-b/HEAD
+DATADIR/work-dir/cvs-test-repo/git-b/branches
+DATADIR/work-dir/cvs-test-repo/git-b/config
+DATADIR/work-dir/cvs-test-repo/git-b/description
+DATADIR/work-dir/cvs-test-repo/git-b/hooks
+DATADIR/work-dir/cvs-test-repo/git-b/info
+DATADIR/work-dir/cvs-test-repo/git-b/info/exclude
+DATADIR/work-dir/cvs-test-repo/git-b/info/refs
+DATADIR/work-dir/cvs-test-repo/git-b/lorry-update-count
+DATADIR/work-dir/cvs-test-repo/git-b/objects
+DATADIR/work-dir/cvs-test-repo/git-b/objects/info
+DATADIR/work-dir/cvs-test-repo/git-b/objects/info/packs
+DATADIR/work-dir/cvs-test-repo/git-b/objects/pack
+DATADIR/work-dir/cvs-test-repo/git-b/objects/pack/pack-file
+DATADIR/work-dir/cvs-test-repo/git-b/objects/pack/pack-file
+DATADIR/work-dir/cvs-test-repo/git-b/packed-refs
+DATADIR/work-dir/cvs-test-repo/git-b/refs
+DATADIR/work-dir/cvs-test-repo/git-b/refs/heads
+DATADIR/work-dir/cvs-test-repo/git-b/refs/tags